import { ScrollingModule } from '@angular/cdk/scrolling';
import * as i6 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Inject } from '@angular/core';
import * as i2$1 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i7 from '@angular/google-maps';
import { GoogleMapsModule } from '@angular/google-maps';
import * as i8 from '@angular/material/legacy-card';
import { MatLegacyCardModule } from '@angular/material/legacy-card';
import * as i1 from '@angular/material/legacy-dialog';
import { MAT_LEGACY_DIALOG_DATA, MatLegacyDialogModule } from '@angular/material/legacy-dialog';
import { MatLegacyTableModule } from '@angular/material/legacy-table';
import { MatSortModule } from '@angular/material/sort';
import { AutoSizeVirtualScrollStrategy, RxVirtualScrollViewportComponent, RxVirtualFor } from '@rx-angular/template/experimental/virtual-scrolling';
import { RxFor } from '@rx-angular/template/for';
import { RxIf } from '@rx-angular/template/if';
import { RxLet } from '@rx-angular/template/let';
import { RxPush } from '@rx-angular/template/push';
import * as i3 from '@smallstack/common-components';
import { FlattenPipe, JsonByPathPipe, JsonStringPipe, LoadingElementDirective, ObjectArrayValuePipe, OverlayComponent, UppercaseSpacePipe, LetDirective, NgForTrackByIdDirective, RenderInViewportDirective, DebugComponentComponent } from '@smallstack/common-components';
import * as i2 from '@smallstack/i18n-components';
import { I18nComponent, CurrencyComponent, DateComponent, DurationComponent } from '@smallstack/i18n-components';
import { QRCodeDialogComponent } from '@smallstack/qrcode-components';
import * as i1$1 from '@smallstack/rx-components';
import { LoaderComponent, StorePropertyComponent, ListContainerComponent, MatSortStoreDirective } from '@smallstack/store-components';
import { MarkdownViewerComponent } from '@smallstack/text-components';
import { IconComponent } from '@smallstack/theme-components';
import * as i5 from '@smallstack/type-components';
import { ShowForPermissionDirective } from '@smallstack/user-components';
import { filterNullish, getSchemaPropertiesKeys, when, convertGeoPointToLatLng, onlyUnique } from '@smallstack/utils';
import { WidgetTreeComponent, BaseWidgetComponent, WidgetTag, WidgetChildComponent } from '@smallstack/widget-core';
import Fuse from 'fuse.js';
import { switchMap, shareReplay, take, tap, map, BehaviorSubject, combineLatest, debounce, interval, of, startWith, firstValueFrom } from 'rxjs';

class DataTableV3DialogComponent {
    constructor(data, dialogRef) {
        this.data = data;
        this.dialogRef = dialogRef;
        data.widgetRendererOptions.dialogRef = dialogRef;
    }
    close() {
        if (this.data.widgetRendererOptions?.editMode === true)
            this.dialogRef.close(this.data.cmsComponent);
        else
            this.dialogRef.close();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3DialogComponent, deps: [{ token: MAT_LEGACY_DIALOG_DATA }, { token: i1.MatLegacyDialogRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.7", type: DataTableV3DialogComponent, isStandalone: true, selector: "ng-component", ngImport: i0, template: "<div mat-dialog-content>\n  <smallstack-widget-tree\n    [(widget)]=\"data.cmsComponent\"\n    [widgetRendererOptions]=\"data.widgetRendererOptions\"\n    [context]=\"data.context\"\n  ></smallstack-widget-tree>\n</div>\n<div mat-dialog-actions class=\"flex flex-row justify-end\">\n  <button (click)=\"close()\" class=\"btn btn-primary\">\n    <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n  </button>\n</div>\n", styles: [".mat-dialog-content{height:calc(100% - 40px);max-height:unset}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "component", type: WidgetTreeComponent, selector: "smallstack-widget-tree", inputs: ["widgetRendererOptions", "widget", "context", "globals", "connections", "rootSockets"], outputs: ["connectionsChange", "widgetChange"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "ngmodule", type: MatLegacyDialogModule }, { kind: "directive", type: i1.MatLegacyDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i1.MatLegacyDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3DialogComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [CommonModule, WidgetTreeComponent, I18nComponent, MatLegacyDialogModule], template: "<div mat-dialog-content>\n  <smallstack-widget-tree\n    [(widget)]=\"data.cmsComponent\"\n    [widgetRendererOptions]=\"data.widgetRendererOptions\"\n    [context]=\"data.context\"\n  ></smallstack-widget-tree>\n</div>\n<div mat-dialog-actions class=\"flex flex-row justify-end\">\n  <button (click)=\"close()\" class=\"btn btn-primary\">\n    <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n  </button>\n</div>\n", styles: [".mat-dialog-content{height:calc(100% - 40px);max-height:unset}\n"] }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_LEGACY_DIALOG_DATA]
                }] }, { type: i1.MatLegacyDialogRef }]; } });

class DataTableV3WidgetComponent extends BaseWidgetComponent {
    constructor(matDialog, notificationService, routerUtilService, frontendTypeRegistry, breakPointService, rxCollectionService) {
        super();
        this.matDialog = matDialog;
        this.notificationService = notificationService;
        this.routerUtilService = routerUtilService;
        this.frontendTypeRegistry = frontendTypeRegistry;
        this.breakPointService = breakPointService;
        this.rxCollectionService = rxCollectionService;
        this.collection$ = this.data$.pipe(filterNullish({ filterEmptyObjects: true }), switchMap((data) => {
            if (!data || !data.typeName)
                return undefined;
            return this.rxCollectionService.getCollection$(data.typeName);
        }), shareReplay());
        // data
        this.tableData$ = this.collection$.pipe(filterNullish(), take(1), switchMap(async (collection) => {
            if (!collection)
                return undefined;
            this.isLoading$.next(true);
            await collection.replicationState.awaitInSync();
            return collection;
        }), switchMap((collection) => {
            if (!collection)
                return [];
            return collection.rxCollection.find().$;
        }), tap(() => this.isLoading$.next(false)), shareReplay());
        this.smallstackType$ = this.data$.pipe(map((tableConfiguration) => tableConfiguration?.typeName), filterNullish(), switchMap((typeName) => this.frontendTypeRegistry.getTypeByPath(typeName)), shareReplay());
        this.searchText$ = new BehaviorSubject(undefined);
        this.isSearching$ = new BehaviorSubject(false);
        this.searchResult$ = combineLatest([
            this.tableData$,
            this.searchText$.pipe(debounce(() => interval(800))),
            this.smallstackType$,
            this.collection$
        ]).pipe(map(([values, searchText, smallstackType, collection]) => {
            if (searchText) {
                this.isSearching$.next(true);
                this.isLoading$.next(true);
                let allProperties = [];
                if (smallstackType?.searchableFields instanceof Array && smallstackType.searchableFields.length > 0)
                    allProperties = smallstackType.searchableFields;
                else
                    allProperties = getSchemaPropertiesKeys(collection.rxCollection.schema.jsonSchema).map((key) => {
                        return { name: key, weight: 10 };
                    });
                const fuse = new Fuse(values.map((val) => val.toJSON()), {
                    keys: allProperties,
                    isCaseSensitive: false,
                    includeScore: true,
                    shouldSort: true
                });
                const result = fuse.search(searchText).map((s) => ({
                    ...s.item,
                    score: when(s.score)
                        .is((s) => s < 0.0000001, () => "Sehr gut")
                        .is((s) => s < 0.0005, () => "Gut")
                        .is((s) => s < 0.005, () => "Mittel")
                        .is((s) => s < 0.1, () => "Ungenau")
                        .default(() => "Schlecht")
                }));
                this.isLoading$.next(false);
                this.isSearching$.next(false);
                return result;
            }
            this.isLoading$.next(false);
            return values.map((val) => val.toJSON());
        }), shareReplay());
        this.hasSearchResults$ = this.searchText$.pipe(map((searchText) => !!searchText));
        this.columns$ = this.data$.pipe(switchMap((tableConfiguration) => {
            if (!tableConfiguration || !tableConfiguration.listProperties)
                return this.smallstackType$.pipe(map((type) => type?.searchableFields?.map((sf) => sf.name) ?? []));
            const columns = tableConfiguration.listProperties.map((lp) => lp.columnName);
            if (this.data?.showEditButton || this.data?.showDeleteButton)
                columns.push("actions");
            if (this.data?.allowMultiDelete || this.data?.showCheckboxes)
                columns.splice(0, 0, "multiSelect");
            return of(columns);
        }));
        // state
        this.isLoading$ = new BehaviorSubject(true);
        this.isEmpty$ = this.tableData$.pipe(startWith(undefined), map((data) => !data));
        this.isMobile$ = this.breakPointService.isMobile$;
        this.selectedIds = [];
        // google maps related stuff
        this.convertGeoPointToLatLng = convertGeoPointToLatLng;
        this.googleMapsOverlayOpened = false;
        this.errors = [];
        this.mappingArray = {};
        this.WidgetTag = WidgetTag;
    }
    qrCodeDialog(value, prefix = "") {
        this.matDialog.closeAll();
        this.matDialog.open(QRCodeDialogComponent, { data: prefix + value, autoFocus: false });
    }
    async openDialog(lp, model) {
        this.matDialog.closeAll();
        if (lp.dialogUrlSyncParameter)
            await this.routerUtilService.addSearchParameter(lp.dialogUrlSyncParameter, model.id);
        void this.matDialog
            .open(DataTableV3DialogComponent, {
            width: lp.dialogWidth,
            height: lp.dialogHeight,
            autoFocus: false,
            data: {
                cmsComponent: lp.dialogComponent,
                widgetRendererOptions: {
                    editMode: this.editMode
                },
                context: model
            }
        })
            .afterClosed()
            .subscribe(async (component) => {
            if (this.editMode === true && component) {
                this.data.listProperties[lp.index].dialogComponent = component;
                this.dataChange.emit(this.data);
            }
            if (lp.dialogUrlSyncParameter)
                await this.routerUtilService.removeSearchParameter(lp.dialogUrlSyncParameter);
        });
    }
    openEditor(model) {
        return async () => {
            const data = await firstValueFrom(this.data$);
            await this.frontendTypeRegistry.openEditor(data.typeName, model);
        };
    }
    deleteData(elem) {
        return async () => {
            const answer = await this.notificationService.popup.confirmation("Datensatz löschen", "Soll der Datensatz wirklich gelöscht werden?", [
                { label: "@@actions.no", color: "primary", value: false },
                { label: "@@actions.yes", color: "error", value: true }
            ]);
            if (answer === true) {
                const data = await firstValueFrom(this.data$);
                const crud = this.frontendTypeRegistry.getCrud(data?.typeName);
                await crud.delete(elem.id);
                const collection = await this.rxCollectionService.getCollection(data?.typeName);
                await collection.rxCollection
                    .findOne(elem.id)
                    .exec()
                    .then((doc) => doc.remove());
            }
        };
    }
    deleteManyData(ids) {
        return async () => {
            const plural = ids.length !== 1;
            const answer = await this.notificationService.popup.confirmation(ids.length + " " + (plural ? "Datensätze" : "Datensatz") + " löschen", plural
                ? "Möchten Sie wirklich die " + ids.length + " selektierten Datensätze löschen?"
                : "Soll der Datensatz wirklich gelöscht werden?", [
                { label: "@@actions.no", classes: "btn btn-outline", value: false },
                { label: "@@actions.yes", classes: "btn btn-error", value: true }
            ]);
            if (answer === true) {
                const data = await firstValueFrom(this.data$);
                const crud = this.frontendTypeRegistry.getCrud(data?.typeName);
                await crud.deleteMany(ids);
                const collection = await this.rxCollectionService.getCollection(data?.typeName);
                for (const elem of ids)
                    await collection.rxCollection
                        .findOne(elem)
                        .exec()
                        .then((doc) => doc.remove());
            }
        };
    }
    async toggleAll(checkboxEvent) {
        const target = checkboxEvent.target;
        const currentData = await firstValueFrom(this.tableData$);
        if (target.checked)
            this.selectedIds = currentData.map((data) => data.id);
        else
            this.selectedIds = [];
    }
    async toggleEntry(id, checkboxEvent) {
        const target = checkboxEvent.target;
        if (target.checked)
            this.selectedIds = onlyUnique([...this.selectedIds, id]);
        else
            this.selectedIds = this.selectedIds.filter((selectedId) => selectedId !== id);
    }
    /** callback fn for when a widget got set */
    async setWidgetListProperty(propertyName, newWidget) {
        const data = await firstValueFrom(this.data$);
        const index = data.listProperties?.findIndex((lp) => lp.property === propertyName);
        if (index === -1)
            throw new Error("Could not find list property by propertyName: " + propertyName);
        data.listProperties[index].widget = newWidget;
        this.dataChange.emit(data);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3WidgetComponent, deps: [{ token: i1.MatLegacyDialog }, { token: i2.NotificationService }, { token: i3.RouterUtilService }, { token: i5.FrontendTypeRegistry }, { token: i3.BreakpointService }, { token: i1$1.RxCollectionService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.1.7", type: DataTableV3WidgetComponent, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<div class=\"form-control m-2\">\n  <div class=\"input-group\">\n    <input\n      #input\n      type=\"text\"\n      placeholder=\"Suchen...\"\n      class=\"input input-bordered w-full shadow-sm\"\n      (keyup)=\"searchText$.next($any($event.target).value)\"\n      (focus)=\"sendSocketData('focused')\"\n      [ngModel]=\"searchText$.value\"\n    />\n    <button\n      *ngIf=\"searchText$.value\"\n      class=\"btn btn-square btn-warning shadow-sm\"\n      (click)=\"searchText$.next(undefined)\"\n    >\n      <smallstack-icon\n        name=\"trash\"\n        theme=\"fluency-systems-regular\"\n        themeColor=\"daisyTheme.warning.textColor\"\n        size=\"md\"\n      ></smallstack-icon>\n    </button>\n    <button class=\"btn btn-square btn-primary shadow-sm\" (click)=\"searchText$.next(input.value)\">\n      <span *rxIf=\"isLoading$; else icon\" class=\"loading loading-spinner\"></span>\n      <ng-template #icon>\n        <smallstack-icon\n          name=\"search\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.primary.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </ng-template>\n    </button>\n  </div>\n</div>\n\n<ng-container *ngIf=\"errors?.length > 0\">\n  <div *ngFor=\"let error of errors\">\n    {{ error }}\n  </div>\n</ng-container>\n<ng-container *rxLet=\"searchResult$; let tableData\">\n  <ng-container *rxLet=\"data$; let tableConfiguration\">\n    <smallstack-loader *rxIf=\"isLoading$; else checkData\"></smallstack-loader>\n    <ng-template #checkData>\n      <div\n        *ngIf=\"tableData === undefined || tableData === null || tableData.length === 0; else showTable\"\n        class=\"text-center text-help m-6\"\n      >\n        Keine Daten vorhanden\n      </div>\n    </ng-template>\n    <ng-template #showTable>\n      <ng-container\n        *ngIf=\"tableConfiguration && tableConfiguration.listProperties?.length > 0; else widgetNotConfigured\"\n      >\n        <div class=\"bordered shadow m-2\">\n          <div class=\"flex flex-row gap-1 justify-evenly rx-table-header\">\n            <div class=\"rx-table-header-cell\">\n              <input\n                type=\"checkbox\"\n                class=\"checkbox checkbox-primary checkbox-sm\"\n                [indeterminate]=\"selectedIds.length !== tableData.length && selectedIds.length !== 0\"\n                [checked]=\"selectedIds.length === tableData.length\"\n                (change)=\"toggleAll($event)\"\n                data-test=\"check-all\"\n              />\n            </div>\n            <div *rxFor=\"let listProperty of tableConfiguration.listProperties\" class=\"rx-table-header-cell\">\n              <smallstack-i18n [data]=\"listProperty.title\"></smallstack-i18n\n            ></div>\n            <div class=\"rx-table-header-cell\">Actions</div>\n          </div>\n          <rx-virtual-scroll-viewport\n            autosize\n            style=\"min-height: 200px\"\n            [ngStyle]=\"{ height: tableConfiguration.tableHeight }\"\n          >\n            <div\n              *rxVirtualFor=\"let element of tableData; let index = index\"\n              class=\"flex flex-row gap-1 w-full rx-table-row\"\n            >\n              <div class=\"checkboxes rx-table-cell\">\n                <input\n                  type=\"checkbox\"\n                  class=\"checkbox checkbox-primary checkbox-sm\"\n                  [checked]=\"selectedIds.includes(element.id)\"\n                  (change)=\"toggleEntry(element.id, $event)\"\n                  attr.data-testid=\"checkbox-{{ index }}\"\n                />\n              </div>\n              <div *rxIf=\"hasSearchResults$\" class=\"text-center rx-table-cell\">\n                <span class=\"text-help\">{{ element.score }}</span>\n              </div>\n              <div *rxFor=\"let lp of tableConfiguration.listProperties\" class=\"rx-table-cell\">\n                <ng-container [ngSwitch]=\"lp.renderer\">\n                  <ng-container *ngSwitchCase=\"'date'\">\n                    <smallstack-date\n                      [format]=\"lp.rendererDateFormat\"\n                      [timestamp]=\"element | jsonByPath: lp.property\"\n                      style=\"white-space: nowrap\"\n                    ></smallstack-date>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'duration'\">\n                    <smallstack-duration [duration]=\"element | jsonByPath: lp.property\"></smallstack-duration>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'icon'\">\n                    <smallstack-icon\n                      size=\"24\"\n                      [alias]=\"\n                        mappingArray[lp.property][element[lp.property]]\n                          ? mappingArray[lp.property][element[lp.property]]\n                          : lp.defaultIcon\n                      \"\n                    ></smallstack-icon>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'image'\">\n                    <smallstack-overlay #overlay>\n                      <div class=\"card card-bordered card-compact shadow-xl bg-white\">\n                        <div class=\"card-body\">\n                          <img [src]=\"element | jsonByPath: lp.property\" class=\"w-80\" />\n                        </div>\n                      </div>\n                    </smallstack-overlay>\n                    <img\n                      class=\"mask mask-square w-16 cursor-pointer\"\n                      [src]=\"element | jsonByPath: lp.property\"\n                      (click)=\"overlay.openOverlay()\"\n                    />\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'storeProperty'\">\n                    <smallstack-store-property\n                      [storeName]=\"lp.rendererStorePropertyStore\"\n                      [property]=\"lp.rendererStorePropertyProperty\"\n                      [modelId]=\"element | flatten: lp.property\"\n                    >\n                    </smallstack-store-property>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'i18n'\">\n                    <ng-container *ngIf=\"lp.i18nPrefix; else unPrefixed\">\n                      <smallstack-i18n\n                        [data]=\"(lp.i18nPrefix ? lp.i18nPrefix : '') + element | jsonByPath: lp.property\"\n                      ></smallstack-i18n>\n                    </ng-container>\n                    <ng-template #unPrefixed>\n                      <smallstack-i18n [data]=\"element | jsonByPath: lp.property\"></smallstack-i18n>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'qrCode'\">\n                    <button class=\"btn-action\" (click)=\"qrCodeDialog(element[lp.property], lp.qrCodePrefix)\">\n                      <smallstack-icon alias=\"qrcode\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'dialog'\">\n                    <button class=\"btn-action\" (click)=\"openDialog(lp, element)\">\n                      <smallstack-icon [name]=\"lp.dialogButtonIcon\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'link'\">\n                    <a\n                      href=\"{{ element | jsonByPath: lp.property }}\"\n                      target=\"{{ lp.openLinkInNewWindow ? '_blank' : undefined }}\"\n                    >\n                      <ng-container *ngIf=\"lp.linkLabel; else noLabel\">\n                        {{ lp.linkLabel }}\n                      </ng-container>\n                      <ng-template #noLabel>\n                        {{ element | jsonByPath: lp.property }}\n                      </ng-template>\n                    </a>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'boolean'\">\n                    <smallstack-icon\n                      name=\"checkmark--v1\"\n                      theme=\"color\"\n                      size=\"24\"\n                      *ngIf=\"(element | jsonByPath: lp.property) === true; else falsy\"\n                    >\n                    </smallstack-icon>\n                    <ng-template #falsy>\n                      <smallstack-icon name=\"delete-sign--v1\" theme=\"color\" size=\"24\"> </smallstack-icon>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'markdown'\">\n                    <smallstack-markdown-viewer [text]=\"element | jsonByPath: lp.property\"></smallstack-markdown-viewer>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'googleMap'\">\n                    <div style=\"cursor: pointer; position: relative\" (click)=\"overlay.openOverlay()\">\n                      <div style=\"position: absolute; width: 100%; height: 100%; z-index: 100\"></div>\n                      <google-map\n                        [width]=\"lp.googleMapsPreviewWidth\"\n                        [height]=\"lp.googleMapsPreviewHeight\"\n                        [zoom]=\"14\"\n                        [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        [options]=\"{\n                          gestureHandling: 'none',\n                          disableDefaultUI: true,\n                          styles: [\n                            {\n                              featureType: 'poi',\n                              elementType: 'labels',\n                              stylers: [{ visibility: 'off' }]\n                            }\n                          ]\n                        }\"\n                      >\n                        <map-marker\n                          [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                          [clickable]=\"false\"\n                        ></map-marker>\n                      </google-map>\n                    </div>\n                    <smallstack-overlay #overlay>\n                      <mat-card class=\"flex flex-col space-y-5\">\n                        <google-map\n                          width=\"350px\"\n                          height=\"350px\"\n                          [zoom]=\"16\"\n                          [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        >\n                          <map-marker\n                            [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                            [clickable]=\"false\"\n                          ></map-marker>\n                        </google-map>\n                        <button class=\"btn btn-primary\" (click)=\"overlay.closeOverlay()\">\n                          <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n                        </button>\n                      </mat-card>\n                    </smallstack-overlay>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'widget'\">\n                    <ng-container *ngIf=\"lp.widget\">\n                      <smallstack-widget-tree\n                        *ngIf=\"lp.widgetContextType === 'full'; else propertyContext\"\n                        [widget]=\"lp.widget\"\n                        (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                        [widgetRendererOptions]=\"{\n                          editMode$: widgetTreeService.editMode$\n                        }\"\n                        [context]=\"{ model: element }\"\n                        [globals]=\"{ model: element }\"\n                      ></smallstack-widget-tree>\n                      <ng-template #propertyContext>\n                        <smallstack-widget-tree\n                          [widget]=\"lp.widget\"\n                          (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                          [widgetRendererOptions]=\"{\n                            editMode$: widgetTreeService.editMode$\n                          }\"\n                          [context]=\"{ model: element | jsonByPath: lp.property }\"\n                          [globals]=\"{ model: element }\"\n                        ></smallstack-widget-tree\n                      ></ng-template>\n                    </ng-container>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'currency'\">\n                    <smallstack-currency\n                      [iso]=\"lp.currency ? lp.currency : 'EUR'\"\n                      [cents]=\"element[lp.property]\"\n                    ></smallstack-currency>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'valueMapping'\">\n                    <span>{{\n                      lp.mappingArray | objectArrayValue: \"value\":element[lp.property]:\"mappedValue\":lp.defaultValue\n                    }}</span>\n                  </ng-container>\n                  <ng-container *ngSwitchDefault>\n                    {{ element | flatten: lp.property | jsonstring }}\n                  </ng-container>\n                </ng-container>\n              </div>\n\n              <div class=\"flex flex-row gap-2 rx-table-cell\">\n                <ng-container *ngIf=\"data?.showDeleteButton\">\n                  <button\n                    class=\"btn-action btn-error\"\n                    [loadingFn]=\"deleteData(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                    data-test=\"delete-entry\"\n                  >\n                    <smallstack-icon alias=\"delete\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <ng-container *ngIf=\"data?.showEditButton\">\n                  <button\n                    class=\"btn-action btn-primary\"\n                    [loadingFn]=\"openEditor(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.update\"\n                    data-test=\"edit-entry\"\n                  >\n                    <smallstack-icon alias=\"edit\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <smallstack-widget-child\n                  [(data)]=\"data\"\n                  property=\"actionWidget\"\n                  [context]=\"{ model: element }\"\n                  (dataChange)=\"dataChange.emit($event)\"\n                ></smallstack-widget-child>\n              </div>\n            </div>\n          </rx-virtual-scroll-viewport>\n        </div>\n        <div class=\"flex flex-row flex-wrap items-start pl-3\">\n          <ng-container *ngIf=\"selectedIds.length > 0\">\n            <ng-container *ngIf=\"data.allowMultiDelete\">\n              <button\n                class=\"btn-action btn-error\"\n                [loadingFn]=\"deleteManyData(selectedIds)\"\n                matTooltip=\"Markierte Datens\u00E4tze l\u00F6schen\"\n                *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n              >\n                <smallstack-icon alias=\"delete\"></smallstack-icon>\n              </button>\n            </ng-container>\n            <smallstack-widget-child\n              property=\"listActionsComponent\"\n              [(data)]=\"data\"\n              [context]=\"{selectedIds}\"\n              [widgetTags]=\"[WidgetTag.ICON, WidgetTag.CONTAINER]\"\n              (dataChange)=\"dataChange.emit($event)\"\n            ></smallstack-widget-child>\n          </ng-container>\n        </div>\n      </ng-container>\n      <div class=\"text-center text-help m-4\" *rxLet=\"tableData$; let realTableData\">\n        {{ realTableData?.length }} Datens\u00E4tze<span *rxIf=\"hasSearchResults$\">\n          | {{ tableData.length }} Suchergebnisse</span\n        ><span *ngIf=\"selectedIds?.length > 0\"> | {{ selectedIds.length }} markiert</span></div\n      >\n    </ng-template>\n    <div\n      style=\"text-align: end; padding-top: 20px; padding-right: 15px\"\n      *showForPermission=\"(smallstackType$ | push)?.permissions?.create\"\n    >\n      <button\n        *ngIf=\"tableConfiguration?.showCreateButton !== false\"\n        class=\"btn btn-primary btn-sm\"\n        [loadingFn]=\"openEditor()\"\n        data-test=\"create\"\n      >\n        <smallstack-i18n data=\"@@actions.create\"></smallstack-i18n>\n      </button>\n    </div>\n  </ng-container>\n</ng-container>\n<ng-template #widgetNotConfigured>\n  <div style=\"height: 60px\" class=\"flex flex-col justify-center items-center\">\n    <i><smallstack-i18n data=\"@@widgets.dataTable.errors.notConfiguredYet\"></smallstack-i18n></i>\n  </div>\n</ng-template>\n", styles: [".rx-table-header{@apply bg-slate-100 font-bold p-2 rounded-t;}.rx-table-header-cell{flex:1;overflow:hidden;@apply p-2;}.rx-table-row{@apply hover:bg-slate-50;}.rx-table-cell{flex:1;overflow:hidden;flex-wrap:wrap;@apply p-2;}.rx-table-cell:first-child{@apply pl-4;}\n"], dependencies: [{ kind: "ngmodule", type: CommonModule }, { kind: "directive", type: i6.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i6.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i6.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: i6.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i6.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i6.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: CurrencyComponent, selector: "smallstack-currency", inputs: ["iso", "value", "euros", "cents"] }, { kind: "component", type: DateComponent, selector: "smallstack-date", inputs: ["timestamp", "format"] }, { kind: "component", type: DurationComponent, selector: "smallstack-duration", inputs: ["start", "end", "duration"] }, { kind: "pipe", type: FlattenPipe, name: "flatten" }, { kind: "ngmodule", type: GoogleMapsModule }, { kind: "component", type: i7.GoogleMap, selector: "google-map", inputs: ["height", "width", "mapTypeId", "center", "zoom", "options"], outputs: ["mapInitialized", "authFailure", "boundsChanged", "centerChanged", "mapClick", "mapDblclick", "mapDrag", "mapDragend", "mapDragstart", "headingChanged", "idle", "maptypeidChanged", "mapMousemove", "mapMouseout", "mapMouseover", "projectionChanged", "mapRightclick", "tilesloaded", "tiltChanged", "zoomChanged"], exportAs: ["googleMap"] }, { kind: "directive", type: i7.MapMarker, selector: "map-marker", inputs: ["title", "position", "label", "clickable", "options", "icon", "visible"], outputs: ["animationChanged", "mapClick", "clickableChanged", "cursorChanged", "mapDblclick", "mapDrag", "mapDragend", "draggableChanged", "mapDragstart", "flatChanged", "iconChanged", "mapMousedown", "mapMouseout", "mapMouseover", "mapMouseup", "positionChanged", "mapRightclick", "shapeChanged", "titleChanged", "visibleChanged", "zindexChanged"], exportAs: ["mapMarker"] }, { kind: "component", type: I18nComponent, selector: "smallstack-i18n", inputs: ["data", "showMissingKey", "replacers", "locale", "translationStore"] }, { kind: "component", type: IconComponent, selector: "smallstack-icon", inputs: ["theme", "size", "name", "alias", "action", "actionSize", "spinning", "actionSpinning", "color", "themeColor", "actionColor", "badge", "dynamic", "badgeColor"], outputs: ["iconError"] }, { kind: "pipe", type: JsonByPathPipe, name: "jsonByPath" }, { kind: "pipe", type: JsonStringPipe, name: "jsonstring" }, { kind: "component", type: LoaderComponent, selector: "smallstack-loader", inputs: ["loading", "color", "size", "loadingText"] }, { kind: "directive", type: LoadingElementDirective, selector: "[loadingFn]", inputs: ["loadingFn", "isLoading"], exportAs: ["loadingFn"] }, { kind: "component", type: MarkdownViewerComponent, selector: "smallstack-markdown-viewer", inputs: ["text"] }, { kind: "ngmodule", type: MatLegacyCardModule }, { kind: "component", type: i8.MatLegacyCard, selector: "mat-card", exportAs: ["matCard"] }, { kind: "ngmodule", type: MatLegacyTableModule }, { kind: "ngmodule", type: MatSortModule }, { kind: "pipe", type: ObjectArrayValuePipe, name: "objectArrayValue" }, { kind: "component", type: OverlayComponent, selector: "smallstack-overlay" }, { kind: "component", type: StorePropertyComponent, selector: "smallstack-store-property", inputs: ["store", "storeName", "modelId", "property", "notFound", "showNotFound"] }, { kind: "component", type: WidgetChildComponent, selector: "smallstack-widget-child", inputs: ["data", "context", "property", "widgetTags"], outputs: ["dataChange"] }, { kind: "component", type: WidgetTreeComponent, selector: "smallstack-widget-tree", inputs: ["widgetRendererOptions", "widget", "context", "globals", "connections", "rootSockets"], outputs: ["connectionsChange", "widgetChange"] }, { kind: "directive", type: ShowForPermissionDirective, selector: "[showForPermission]", inputs: ["showForPermission", "showForPermissionTenantId"] }, { kind: "ngmodule", type: ScrollingModule }, { kind: "pipe", type: RxPush, name: "push" }, { kind: "directive", type: RxFor, selector: "[rxFor][rxForOf]", inputs: ["rxForOf", "rxForTemplate", "rxForStrategy", "rxForParent", "rxForPatchZone", "rxForTrackBy", "rxForRenderCallback"] }, { kind: "directive", type: RxLet, selector: "[rxLet]", inputs: ["rxLet", "rxLetStrategy", "rxLetComplete", "rxLetError", "rxLetSuspense", "rxLetContextTrigger", "rxLetCompleteTrigger", "rxLetErrorTrigger", "rxLetSuspenseTrigger", "rxLetNextTrigger", "rxLetRenderCallback", "rxLetParent", "rxLetPatchZone"], outputs: ["rendered"] }, { kind: "directive", type: RxIf, selector: "[rxIf]", inputs: ["rxIf", "rxIfStrategy", "rxIfElse", "rxIfThen", "rxIfSuspense", "rxIfComplete", "rxIfError", "rxIfContextTrigger", "rxIfNextTrigger", "rxIfSuspenseTrigger", "rxIfErrorTrigger", "rxIfCompleteTrigger", "rxIfParent", "rxIfPatchZone", "rxIfRenderCallback"] }, { kind: "directive", type: AutoSizeVirtualScrollStrategy, selector: "rx-virtual-scroll-viewport[autosize]", inputs: ["runwayItems", "runwayItemsOpposite", "tombstoneSize", "resizeObserverConfig", "withSyncScrollbar"] }, { kind: "component", type: RxVirtualScrollViewportComponent, selector: "rx-virtual-scroll-viewport", outputs: ["viewRange", "scrolledIndexChange"] }, { kind: "directive", type: RxVirtualFor, selector: "[rxVirtualFor][rxVirtualForOf]", inputs: ["rxVirtualForOf", "rxVirtualForTemplate", "rxVirtualForStrategy", "rxVirtualForTemplateCacheSize", "rxVirtualForParent", "rxVirtualForPatchZone", "rxVirtualForTrackBy", "rxVirtualForRenderCallback"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.1.7", ngImport: i0, type: DataTableV3WidgetComponent, decorators: [{
            type: Component,
            args: [{ changeDetection: ChangeDetectionStrategy.OnPush, standalone: true, imports: [
                        CommonModule,
                        FormsModule,
                        CurrencyComponent,
                        DateComponent,
                        DurationComponent,
                        FlattenPipe,
                        GoogleMapsModule,
                        I18nComponent,
                        IconComponent,
                        JsonByPathPipe,
                        JsonStringPipe,
                        ListContainerComponent,
                        LoaderComponent,
                        LoadingElementDirective,
                        MarkdownViewerComponent,
                        MatLegacyCardModule,
                        MatLegacyTableModule,
                        MatSortModule,
                        MatSortStoreDirective,
                        ObjectArrayValuePipe,
                        OverlayComponent,
                        StorePropertyComponent,
                        UppercaseSpacePipe,
                        WidgetChildComponent,
                        WidgetTreeComponent,
                        ShowForPermissionDirective,
                        LetDirective,
                        MatSortModule,
                        NgForTrackByIdDirective,
                        ScrollingModule,
                        RenderInViewportDirective,
                        RxPush,
                        RxFor,
                        RxLet,
                        RxIf,
                        DebugComponentComponent,
                        AutoSizeVirtualScrollStrategy,
                        RxVirtualScrollViewportComponent,
                        RxVirtualFor
                    ], template: "<div class=\"form-control m-2\">\n  <div class=\"input-group\">\n    <input\n      #input\n      type=\"text\"\n      placeholder=\"Suchen...\"\n      class=\"input input-bordered w-full shadow-sm\"\n      (keyup)=\"searchText$.next($any($event.target).value)\"\n      (focus)=\"sendSocketData('focused')\"\n      [ngModel]=\"searchText$.value\"\n    />\n    <button\n      *ngIf=\"searchText$.value\"\n      class=\"btn btn-square btn-warning shadow-sm\"\n      (click)=\"searchText$.next(undefined)\"\n    >\n      <smallstack-icon\n        name=\"trash\"\n        theme=\"fluency-systems-regular\"\n        themeColor=\"daisyTheme.warning.textColor\"\n        size=\"md\"\n      ></smallstack-icon>\n    </button>\n    <button class=\"btn btn-square btn-primary shadow-sm\" (click)=\"searchText$.next(input.value)\">\n      <span *rxIf=\"isLoading$; else icon\" class=\"loading loading-spinner\"></span>\n      <ng-template #icon>\n        <smallstack-icon\n          name=\"search\"\n          theme=\"fluency-systems-regular\"\n          themeColor=\"daisyTheme.primary.textColor\"\n          size=\"md\"\n        ></smallstack-icon>\n      </ng-template>\n    </button>\n  </div>\n</div>\n\n<ng-container *ngIf=\"errors?.length > 0\">\n  <div *ngFor=\"let error of errors\">\n    {{ error }}\n  </div>\n</ng-container>\n<ng-container *rxLet=\"searchResult$; let tableData\">\n  <ng-container *rxLet=\"data$; let tableConfiguration\">\n    <smallstack-loader *rxIf=\"isLoading$; else checkData\"></smallstack-loader>\n    <ng-template #checkData>\n      <div\n        *ngIf=\"tableData === undefined || tableData === null || tableData.length === 0; else showTable\"\n        class=\"text-center text-help m-6\"\n      >\n        Keine Daten vorhanden\n      </div>\n    </ng-template>\n    <ng-template #showTable>\n      <ng-container\n        *ngIf=\"tableConfiguration && tableConfiguration.listProperties?.length > 0; else widgetNotConfigured\"\n      >\n        <div class=\"bordered shadow m-2\">\n          <div class=\"flex flex-row gap-1 justify-evenly rx-table-header\">\n            <div class=\"rx-table-header-cell\">\n              <input\n                type=\"checkbox\"\n                class=\"checkbox checkbox-primary checkbox-sm\"\n                [indeterminate]=\"selectedIds.length !== tableData.length && selectedIds.length !== 0\"\n                [checked]=\"selectedIds.length === tableData.length\"\n                (change)=\"toggleAll($event)\"\n                data-test=\"check-all\"\n              />\n            </div>\n            <div *rxFor=\"let listProperty of tableConfiguration.listProperties\" class=\"rx-table-header-cell\">\n              <smallstack-i18n [data]=\"listProperty.title\"></smallstack-i18n\n            ></div>\n            <div class=\"rx-table-header-cell\">Actions</div>\n          </div>\n          <rx-virtual-scroll-viewport\n            autosize\n            style=\"min-height: 200px\"\n            [ngStyle]=\"{ height: tableConfiguration.tableHeight }\"\n          >\n            <div\n              *rxVirtualFor=\"let element of tableData; let index = index\"\n              class=\"flex flex-row gap-1 w-full rx-table-row\"\n            >\n              <div class=\"checkboxes rx-table-cell\">\n                <input\n                  type=\"checkbox\"\n                  class=\"checkbox checkbox-primary checkbox-sm\"\n                  [checked]=\"selectedIds.includes(element.id)\"\n                  (change)=\"toggleEntry(element.id, $event)\"\n                  attr.data-testid=\"checkbox-{{ index }}\"\n                />\n              </div>\n              <div *rxIf=\"hasSearchResults$\" class=\"text-center rx-table-cell\">\n                <span class=\"text-help\">{{ element.score }}</span>\n              </div>\n              <div *rxFor=\"let lp of tableConfiguration.listProperties\" class=\"rx-table-cell\">\n                <ng-container [ngSwitch]=\"lp.renderer\">\n                  <ng-container *ngSwitchCase=\"'date'\">\n                    <smallstack-date\n                      [format]=\"lp.rendererDateFormat\"\n                      [timestamp]=\"element | jsonByPath: lp.property\"\n                      style=\"white-space: nowrap\"\n                    ></smallstack-date>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'duration'\">\n                    <smallstack-duration [duration]=\"element | jsonByPath: lp.property\"></smallstack-duration>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'icon'\">\n                    <smallstack-icon\n                      size=\"24\"\n                      [alias]=\"\n                        mappingArray[lp.property][element[lp.property]]\n                          ? mappingArray[lp.property][element[lp.property]]\n                          : lp.defaultIcon\n                      \"\n                    ></smallstack-icon>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'image'\">\n                    <smallstack-overlay #overlay>\n                      <div class=\"card card-bordered card-compact shadow-xl bg-white\">\n                        <div class=\"card-body\">\n                          <img [src]=\"element | jsonByPath: lp.property\" class=\"w-80\" />\n                        </div>\n                      </div>\n                    </smallstack-overlay>\n                    <img\n                      class=\"mask mask-square w-16 cursor-pointer\"\n                      [src]=\"element | jsonByPath: lp.property\"\n                      (click)=\"overlay.openOverlay()\"\n                    />\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'storeProperty'\">\n                    <smallstack-store-property\n                      [storeName]=\"lp.rendererStorePropertyStore\"\n                      [property]=\"lp.rendererStorePropertyProperty\"\n                      [modelId]=\"element | flatten: lp.property\"\n                    >\n                    </smallstack-store-property>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'i18n'\">\n                    <ng-container *ngIf=\"lp.i18nPrefix; else unPrefixed\">\n                      <smallstack-i18n\n                        [data]=\"(lp.i18nPrefix ? lp.i18nPrefix : '') + element | jsonByPath: lp.property\"\n                      ></smallstack-i18n>\n                    </ng-container>\n                    <ng-template #unPrefixed>\n                      <smallstack-i18n [data]=\"element | jsonByPath: lp.property\"></smallstack-i18n>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'qrCode'\">\n                    <button class=\"btn-action\" (click)=\"qrCodeDialog(element[lp.property], lp.qrCodePrefix)\">\n                      <smallstack-icon alias=\"qrcode\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'dialog'\">\n                    <button class=\"btn-action\" (click)=\"openDialog(lp, element)\">\n                      <smallstack-icon [name]=\"lp.dialogButtonIcon\"></smallstack-icon>\n                    </button>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'link'\">\n                    <a\n                      href=\"{{ element | jsonByPath: lp.property }}\"\n                      target=\"{{ lp.openLinkInNewWindow ? '_blank' : undefined }}\"\n                    >\n                      <ng-container *ngIf=\"lp.linkLabel; else noLabel\">\n                        {{ lp.linkLabel }}\n                      </ng-container>\n                      <ng-template #noLabel>\n                        {{ element | jsonByPath: lp.property }}\n                      </ng-template>\n                    </a>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'boolean'\">\n                    <smallstack-icon\n                      name=\"checkmark--v1\"\n                      theme=\"color\"\n                      size=\"24\"\n                      *ngIf=\"(element | jsonByPath: lp.property) === true; else falsy\"\n                    >\n                    </smallstack-icon>\n                    <ng-template #falsy>\n                      <smallstack-icon name=\"delete-sign--v1\" theme=\"color\" size=\"24\"> </smallstack-icon>\n                    </ng-template>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'markdown'\">\n                    <smallstack-markdown-viewer [text]=\"element | jsonByPath: lp.property\"></smallstack-markdown-viewer>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'googleMap'\">\n                    <div style=\"cursor: pointer; position: relative\" (click)=\"overlay.openOverlay()\">\n                      <div style=\"position: absolute; width: 100%; height: 100%; z-index: 100\"></div>\n                      <google-map\n                        [width]=\"lp.googleMapsPreviewWidth\"\n                        [height]=\"lp.googleMapsPreviewHeight\"\n                        [zoom]=\"14\"\n                        [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        [options]=\"{\n                          gestureHandling: 'none',\n                          disableDefaultUI: true,\n                          styles: [\n                            {\n                              featureType: 'poi',\n                              elementType: 'labels',\n                              stylers: [{ visibility: 'off' }]\n                            }\n                          ]\n                        }\"\n                      >\n                        <map-marker\n                          [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                          [clickable]=\"false\"\n                        ></map-marker>\n                      </google-map>\n                    </div>\n                    <smallstack-overlay #overlay>\n                      <mat-card class=\"flex flex-col space-y-5\">\n                        <google-map\n                          width=\"350px\"\n                          height=\"350px\"\n                          [zoom]=\"16\"\n                          [center]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                        >\n                          <map-marker\n                            [position]=\"convertGeoPointToLatLng(element[lp.property].geoJson)\"\n                            [clickable]=\"false\"\n                          ></map-marker>\n                        </google-map>\n                        <button class=\"btn btn-primary\" (click)=\"overlay.closeOverlay()\">\n                          <smallstack-i18n data=\"@@actions.close\"></smallstack-i18n>\n                        </button>\n                      </mat-card>\n                    </smallstack-overlay>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'widget'\">\n                    <ng-container *ngIf=\"lp.widget\">\n                      <smallstack-widget-tree\n                        *ngIf=\"lp.widgetContextType === 'full'; else propertyContext\"\n                        [widget]=\"lp.widget\"\n                        (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                        [widgetRendererOptions]=\"{\n                          editMode$: widgetTreeService.editMode$\n                        }\"\n                        [context]=\"{ model: element }\"\n                        [globals]=\"{ model: element }\"\n                      ></smallstack-widget-tree>\n                      <ng-template #propertyContext>\n                        <smallstack-widget-tree\n                          [widget]=\"lp.widget\"\n                          (widgetChange)=\"setWidgetListProperty(lp.property, $event)\"\n                          [widgetRendererOptions]=\"{\n                            editMode$: widgetTreeService.editMode$\n                          }\"\n                          [context]=\"{ model: element | jsonByPath: lp.property }\"\n                          [globals]=\"{ model: element }\"\n                        ></smallstack-widget-tree\n                      ></ng-template>\n                    </ng-container>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'currency'\">\n                    <smallstack-currency\n                      [iso]=\"lp.currency ? lp.currency : 'EUR'\"\n                      [cents]=\"element[lp.property]\"\n                    ></smallstack-currency>\n                  </ng-container>\n                  <ng-container *ngSwitchCase=\"'valueMapping'\">\n                    <span>{{\n                      lp.mappingArray | objectArrayValue: \"value\":element[lp.property]:\"mappedValue\":lp.defaultValue\n                    }}</span>\n                  </ng-container>\n                  <ng-container *ngSwitchDefault>\n                    {{ element | flatten: lp.property | jsonstring }}\n                  </ng-container>\n                </ng-container>\n              </div>\n\n              <div class=\"flex flex-row gap-2 rx-table-cell\">\n                <ng-container *ngIf=\"data?.showDeleteButton\">\n                  <button\n                    class=\"btn-action btn-error\"\n                    [loadingFn]=\"deleteData(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n                    data-test=\"delete-entry\"\n                  >\n                    <smallstack-icon alias=\"delete\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <ng-container *ngIf=\"data?.showEditButton\">\n                  <button\n                    class=\"btn-action btn-primary\"\n                    [loadingFn]=\"openEditor(element)\"\n                    *showForPermission=\"(smallstackType$ | push)?.permissions?.update\"\n                    data-test=\"edit-entry\"\n                  >\n                    <smallstack-icon alias=\"edit\"></smallstack-icon>\n                  </button>\n                </ng-container>\n                <smallstack-widget-child\n                  [(data)]=\"data\"\n                  property=\"actionWidget\"\n                  [context]=\"{ model: element }\"\n                  (dataChange)=\"dataChange.emit($event)\"\n                ></smallstack-widget-child>\n              </div>\n            </div>\n          </rx-virtual-scroll-viewport>\n        </div>\n        <div class=\"flex flex-row flex-wrap items-start pl-3\">\n          <ng-container *ngIf=\"selectedIds.length > 0\">\n            <ng-container *ngIf=\"data.allowMultiDelete\">\n              <button\n                class=\"btn-action btn-error\"\n                [loadingFn]=\"deleteManyData(selectedIds)\"\n                matTooltip=\"Markierte Datens\u00E4tze l\u00F6schen\"\n                *showForPermission=\"(smallstackType$ | push)?.permissions?.delete\"\n              >\n                <smallstack-icon alias=\"delete\"></smallstack-icon>\n              </button>\n            </ng-container>\n            <smallstack-widget-child\n              property=\"listActionsComponent\"\n              [(data)]=\"data\"\n              [context]=\"{selectedIds}\"\n              [widgetTags]=\"[WidgetTag.ICON, WidgetTag.CONTAINER]\"\n              (dataChange)=\"dataChange.emit($event)\"\n            ></smallstack-widget-child>\n          </ng-container>\n        </div>\n      </ng-container>\n      <div class=\"text-center text-help m-4\" *rxLet=\"tableData$; let realTableData\">\n        {{ realTableData?.length }} Datens\u00E4tze<span *rxIf=\"hasSearchResults$\">\n          | {{ tableData.length }} Suchergebnisse</span\n        ><span *ngIf=\"selectedIds?.length > 0\"> | {{ selectedIds.length }} markiert</span></div\n      >\n    </ng-template>\n    <div\n      style=\"text-align: end; padding-top: 20px; padding-right: 15px\"\n      *showForPermission=\"(smallstackType$ | push)?.permissions?.create\"\n    >\n      <button\n        *ngIf=\"tableConfiguration?.showCreateButton !== false\"\n        class=\"btn btn-primary btn-sm\"\n        [loadingFn]=\"openEditor()\"\n        data-test=\"create\"\n      >\n        <smallstack-i18n data=\"@@actions.create\"></smallstack-i18n>\n      </button>\n    </div>\n  </ng-container>\n</ng-container>\n<ng-template #widgetNotConfigured>\n  <div style=\"height: 60px\" class=\"flex flex-col justify-center items-center\">\n    <i><smallstack-i18n data=\"@@widgets.dataTable.errors.notConfiguredYet\"></smallstack-i18n></i>\n  </div>\n</ng-template>\n", styles: [".rx-table-header{@apply bg-slate-100 font-bold p-2 rounded-t;}.rx-table-header-cell{flex:1;overflow:hidden;@apply p-2;}.rx-table-row{@apply hover:bg-slate-50;}.rx-table-cell{flex:1;overflow:hidden;flex-wrap:wrap;@apply p-2;}.rx-table-cell:first-child{@apply pl-4;}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.MatLegacyDialog }, { type: i2.NotificationService }, { type: i3.RouterUtilService }, { type: i5.FrontendTypeRegistry }, { type: i3.BreakpointService }, { type: i1$1.RxCollectionService }]; } });

export { DataTableV3WidgetComponent };
//# sourceMappingURL=smallstack-data-widgets-data-table-v3-widget.component-2ccff6b0.mjs.map
